      SUBROUTINE CALC_TOTAL_IMPED(NBJ,NEELEM,NENP,nh,NPNE,NVJE,NXI,NYNE,
     '  RESISNE,INERTNE,COMPLIANCENE, RESISTOTAL,REACTTOTAL,XP,YP,ERROR,*)

C#### Subroutine: CALC_TOTAL_IMPED
C###  Description:  
      
      IMPLICIT NONE
      INCLUDE 'b00.cmn'
      INCLUDE 'geom00.cmn'
      INCLUDE 'lung00.cmn'
      INCLUDE 'pulm00.cmn'
      INCLUDE 'tol00.cmn'

!     Parameter List
      INTEGER NBJ(NJM,NEM),NEELEM(0:NE_R_M),NENP(NPM,0:NEPM),
     '  nh,NPNE(NNM,NBFM,NEM),NVJE(NNM,NBFM,NJM,NEM),
     '  NXI(-NIM:NIM,0:NEIM,0:NEM),NYNE(NAM,NHM,0:NRCM,NCM,NEM)
      REAL*8 RESISNE(NE_R_M),INERTNE(NE_R_M),COMPLIANCENE(NE_R_M),REACTNE(ne),
     &	RESISTOTAL(NE_R_M),REACTTOTAL(NE_R_M),XP(NKM,NVM,NJM,NPM),YP(NYM)
      CHARACTER ERROR*(*)

!     Local Variables
      INTEGER na,nb,ne,ne2,next,nj,noelem,noelem2,np1,np2,nv1,nv2,ny
      REAL*8 avrad,dens,length,SUMRESIS,Re,visc,zeta, 
     &	gasC, wallC, wallCfactor, Patmos, omega
      
      COMPLEX*16 impedbr, impedsum, impedtot
      CALL ENTERS('CALC_TOTAL_IMPED',*9999)

      visc=1.820d-5 !in g.mm-1.s-1
      dens=1.127d-6 !in g.mm-3
      Patmos=101325.d0 !Pascals = g.mm-1.s2
      wallCfactor = 0.d0 ! How do we get this?
      omega = 6.d0 *2.d0*pi ! 6Hz

      DO noelem=1,NEELEM(0)
        ne=NEELEM(noelem)
        nb=NBJ(1,ne)
        np1=NPNE(1,nb,ne)
        np2=NPNE(2,nb,ne)
        nv1=NVJE(1,nb,nj_radius,ne)
        nv2=NVJE(2,nb,nj_radius,ne)
        avrad=0.5d0*(XP(1,nv1,nj_radius,np1)+XP(1,nv2,nj_radius,np2))
        CALL ASSERT(DABS(avrad).GT.ZERO_TOL,
     &  '>> zero radii: set radius values correctly',ERROR,*9999)
        na=1 !for FLOW
        ny=NYNE(na,nh,1,1,ne) !ny for for flow
        Re=DABS(YP(ny))*2.d0*dens/(PI*avrad*visc)
        length=0.d0
        DO nj=1,NJT
          length=length+(XP(1,1,nj,np1)-XP(1,1,nj,np2))**2.d0
        ENDDO
        length=DSQRT(length)
        zeta=DSQRT(2.d0*avrad*Re/length)*1.85d0/(4.d0*DSQRT(2.d0))
        IF(zeta.LT.1.d0) zeta=1.d0
        RESISNE(ne)=128.0d0*length*visc/(pi*(2.d0*avrad)**4.d0)*zeta 
	RESISTTOTAL(ne) = RESISNE(ne)
C	Want to have complex impedance - flow resistance (real) + compliance (-imag) + inertance (+imag)
C	Compute inertance from gas density 
	INERTNE(ne) = elength * dens / (pi * avrad**2.d0) 
C	Can compute compliance from gas compression + wall compliance assumptions/parameters
	gasC = elength * avrad**2.d0 * pi / Patmos ! volume / pressure
	wallC = elength * wallCfactor  ! Needs to be calculated for each airway 
	COMPLIANCENE(ne) = gasC + wallC
	REACTNE(ne) = INERTNE(ne) * omega - 1.d0 / (COMPLIANCENE(ne) * omega)
      ENDDO

C	Need to set up RESITTOTAL and REACTOTAL in the terminal branches to begin recursion
C	Incorporate some measure of tissue impedance - or at least add the compliance
C	of the alveoli, (and contribution of chest wall, )

      DO noelem=NEELEM(0),1,-1
        ne=NEELEM(noelem)
        impedsum=(0.d0, 0.d0)  ! Sum up child branch impedances
        DO noelem2=1,NXI(1,0,ne)
          ne2=NXI(1,noelem2,ne) ! Get child branch indices. Don't quite understand this NXI
	  impedbr = (RESITTOTAL(ne2), REACTTOTAL(ne2)) ! Make branch impedance into complex
          impedsum=impedsum+1.d0/impedbr  ! Sum up reciprocals
        ENDDO !noelem2
        impedtotal=(RESISNE(ne),REACTNE(ne)) + 1.d0/impedsum
	RESITTOTAL(ne) = DREAL(impedtotal)  ! Convert back to the real arrays
	REACTTOTAL(ne) = DIMAG(impedtotal)
      ENDDO !noelem

      CALL EXITS('CALC_TOTAL_IMPED')
      RETURN
 9999 CALL ERRORS('CALC_TOTAL_IMPED',ERROR)
      CALL EXITS('CALC_TOTAL_IMPED')
      RETURN 1
      END

